#include <iostream>
#include <cstdlib>
#include <ctime>
using namespace std;


class Animal {

public:

	virtual void speak() const {
		cout << "..." << endl;
	}

	virtual ~Animal() {
		cout << "  ~Animal()" << endl;
	}

};

class Dog: public Animal {

public:

	virtual void speak() const {
		cout << "Wuff!" << endl;
	}

	virtual ~Dog() {
		cout << "  ~Dog()";
	}

};

class Cat: public Animal {

public:

	virtual void speak() const {
		cout << "Meow!" << endl;
	}

};

class Fish: public Animal {

public:

	virtual void speak() const {
		cout << "Blub!" << endl;
	}

};

Animal* createAnimal() {
	switch(rand() % 3) {
	case 0:
		return new Fish();
	case 1:
		return new Dog();
	case 2:
		return new Cat();
	}
}

int main() {
	srand(time(0));
	for(int i = 0; i < 10; ++i) {
		Animal *animal = createAnimal();
		animal->speak();
		delete animal;
	}

	return 0;
}